# PHP 资源大全中文版

我想很多程序员应该记得 GitHub 上有一个 Awesome - XXX 系列的资源整理。[awesome-php](https://github.com/ziadoz/awesome-php) 就是 ziadoz 发起维护的 PHP 资源列表，内容包括：库、框架、模板、安全、代码分析、日志、第三方库、配置工具、Web 工具、书籍、电子书、经典博文等。

Awesome 系列虽然挺全，但基本只对收录的资源做了极为简要的介绍，如果有更详细的中文介绍，对相应开发者的帮助会更大。这也是我们发起这个开源项目的初衷。

* * *

### 我们要做什么？

- 基于 awesome-php 资源列表，我们将对各个资源项进行编译整理。

### 如何参与本项目？

### 本项目的参与者

- 维护者：[tangyouhua](https://github.com/tangyouhua)

- 贡献者：[cucr](http://www.importnew.com/members/cucr)、[欧w](http://hao.importnew.com/author/ljxjxqht/)、[邢敏](http://github.com/dfghj44444)、[冰斌](http://hao.importnew.com/author/libing1209/)、[wispedia](http://www.importnew.com/members/wispedia/)、[CmderQ](https://github.com/CmderQ)、[kevinskywalker](https://github.com/kevinskywalker)、You

注：名单不分排名，不定期补充更新

* * *

<!-- ### 奖励计划

虽然奖励可能并不是你加入的主要原因，但还是有必要提一下：

* 整理超过 20 个资源后，可在伯乐在线上开通打赏；
* 每整理 20 个资源，有机会获得技术书籍或各种有意思的创意、极客产品；
* [官奖励详情网](http://hao.importnew.com/rewards/)

* * * -->


## 依赖管理

_依赖和包管理库_

*   Composer/Packagist：一个包和依赖管理器 [Composer官网](http://getcomposer.org/)/[Packagist官网](http://packagist.org/)
*   Composer Installers：一个多框架Composer库安装器 [官网](https://github.com/composer/installers)
*   Pickle：一个PHP扩展安装器 [官网](https://github.com/FriendsOfPHP/pickle)

## 其他的依赖管理

_其他的相关依赖管理_

*   Satis：一个静态Composer存储库生成器 [官网](https://github.com/composer/satis)
*   Composition：一个在运行时检查Composer环境的库 [官网](https://github.com/bamarni/composition)
*   Version：语义版本的解析和比较库 [官网](https://github.com/herrera-io/php-version)
*   NameSpacer：转化下划线到命名空间的库 [官网](https://github.com/ralphschindler/Namespacer)
*   Patch Installer：使用Composer安装补丁的库 [官网](https://github.com/goatherd/patch-installer) 
*   Composer Checker：校验Composer配置的工具 [官网](https://github.com/silpion/composer-checker)

## 框架

_Web开发框架_

*   Symfony2：一个独立组件组成的框架 [官网](http://symfony.com/)
*   Zend Framework 2：另一个由独立组件组成的框架 [官网](http://framework.zend.com/)
*   Laravel 4：另一个PHP框架 [官网](http://laravel.com/)
*   Aura PHP：独立组件的框架 [官网](http://auraphp.com/)
*   Yii2： 另一个PHP框架 [官网](https://github.com/yiisoft/yii2/)
*   Nette： 另一个由个体组件组成的框架 [官网](http://nette.org/)
*   PPI Framework 2：一个互操作性框架 [官网](http://www.ppi.io/)
*   [Phalcon](http://hao.importnew.com/phalcon/)：通过C扩展实现的框架 [官网](http://phalconphp.com/en/)、[Github](https://github.com/phalcon/cphalcon)

## 其他框架

_其他Web开发框架_

*   Symfony CMF：创建自定义CMS的内容管理框架 [官网](https://github.com/symfony-cmf/symfony-cmf)
*   Knp RAD Bundle：Symfony 2的快速应用程序（RAD）包 [官网](http://rad.knplabs.com/)

## 框架组件

_来自Web开发框架的独立组件_

*   Symfony2 Components：Symfony2组件 [官网](http://symfony.com/doc/master/components/index.html)
*   Zend Framework 2 Components：ZF2组件 [官网](https://packages.zendframework.com/)
*   Aura Components：PHP5.4组件包 [官网](http://auraphp.github.com/)
*   Hoa Project：另一个PHP组件包 [官网](http://hoa-project.net/En/)
*   Swoft: 基于 Swoole 原生协程的新时代 PHP 全栈式协程框架 [官网](https://www.swoft.org/) [GitHub] (https://github.com/swoft-cloud/swoft)

## 微型框架

_微型框架和路由_

*   Silex：基于Symfony2组件的微型框架 [官网](http://silex.sensiolabs.org/)
*   Slim：另一个简单的微型框架 [官网](http://www.slimframework.com/)
*   Bullet PHP：用于构建REST APIs的微型框架 [官网](http://bulletphp.com/)
*   Fast Route：快速路由库 [官网](https://github.com/nikic/FastRoute)
*   Pux：另一个快速路由库 [官网](https://github.com/c9s/Pux)

## 其他微型框架

_其他相关的微型框架和路由_

*   Silex Skeleton：Silex的项目架构 [官网](https://github.com/fabpot/Silex-Skeleton)
*   Silex Web Profiler：Silex web调试工具条 [官网](https://github.com/silexphp/Silex-WebProfiler)
*   Stack： Silex/Symfony的可堆叠中间件库 [官网](https://github.com/stackphp)
*   Slim Skeleton：Slim架构 [官网](https://github.com/codeguy/Slim-Skeleton)
*   Slim View：Slim的自定义视图集合 [官网](https://github.com/codeguy/Slim-Views)
*   Slim Middleware：Slim的自定义中间件集合 [官网](https://github.com/codeguy/Slim-Middleware)
*   [phy-yaf](http://hao.importnew.com/phy-yaf/)：一个用C语言编写的php框架 [官网](http://www.php.net/manual/en/book.yaf.php)

## 模板

_模板化和词法分析的库和工具_

*   Twig：一个全面的模板语言 [官网](http://twig.sensiolabs.org/)
*   Twig Cache Extension：一个用于Twig的模板片段缓存库 [官网](https://github.com/asm89/twig-cache-extension)
*   Mustache：一个Mustache模板语言的PHP实现 [官网](https://github.com/bobthecow/mustache.php)
*   Phly Mustache：另一个Mustache模板语言的PHP实现 [官网](https://github.com/weierophinney/phly_mustache)
*   MtHaml： 一个HAML 模板语言的PHP实现 [官网](https://github.com/arnaud-lb/MtHaml)
*   PHPTAL：一个 [TAL](http://en.wikipedia.org/wiki/Template_Attribute_Language) 模板语言的PHP实现 [官网](http://phptal.org/)
*   Plates：一个原生PHP模板库 [官网](http://platesphp.com/)
*   Lex：一个轻量级模板解析器 [官网](https://github.com/pyrocms/lex)

## 静态站点生成器

_预处理工具来生成Web页面的内容。_

*   Sculpin：转换Markdown和Twig为静态HTML的工具 [官网](http://sculpin.io/)
*   Phrozn： 另一个转换Textile，Markdown和Twig为HTML的工具 [官网](http://phrozn.info/)

## HTTP

_用于HTTP和网站爬取的库_

*   Guzzle：一个全面的HTTP客户端 [官网](https://github.com/guzzle/guzzle)
*   Buzz：另一个HTTP客户端 [官网](https://github.com/kriswallsmith/Buzz)
*   Requests：一个简单的HTTP库 [官网](https://github.com/rmccue/Requests)
*   HTTPFul：一个链式HTTP库 [官网](https://github.com/nategood/httpful)
*   Goutte：一个简单的web爬取器 [官网](https://github.com/fabpot/Goutte)
*   PHP VCR：录制和重放HTTP请求的库 [官网](http://php-vcr.github.io/)

## URL

_解析URL的库_

*   Purl：一个URL处理库 [官网](https://github.com/jwage/purl)
*   PHP Domain Parser：一个本地前缀解析库 [官网](https://github.com/jeremykendall/php-domain-parser)

## Email

_发送和解析邮件的库_

*   SwiftMailer：一个邮件解决方案 [官网](http://swiftmailer.org/)
*   PHPMailer：另一个邮件解决方案 [官网](https://github.com/PHPMailer/PHPMailer)
*   Fetch：一个IMAP库 [官网](https://github.com/tedivm/Fetch)
*   Email Reply Parser：一个邮件回复解析库 [官网](https://github.com/willdurand/EmailReplyParser)
*   Stampie：邮件服务库，不如 [SendGrid](http://sendgrid.com/), [PostMark](http://postmarkapp.com/), [MailGun](http://www.mailgun.com/) 和 [Mandrill](http://www.mandrill.com/). [官网](https://github.com/henrikbjorn/Stampie)
*   CssToInlineStyles：一个在邮件模板内联CSS的库 [官网](https://github.com/tijsverkoyen/CssToInlineStyles)

## 文件

_文件处理和MIME类型检测库_

*   Gaufrette：一个文件系统抽象层 [官网](https://github.com/KnpLabs/Gaufrette)
*   Flysystem：另一个文件系统抽象层 [官网](https://github.com/FrenkyNet/Flysystem)
*   Canal：一个检测互联网媒体类型的库 [官网](https://github.com/dflydev/dflydev-canal)
*   Apache MIME Types：一个解析Apache MIME类型的库 [官网](https://github.com/dflydev/dflydev-apache-mime-types)
*   Ferret：一个MIME检测库 [官网](https://github.com/versionable/Ferret)
*   Hoa Mime：另一个MIME检测库 [官网](https://github.com/hoaproject/Mime)
*   Lurker：一个资源跟踪库 [官网](https://github.com/henrikbjorn/Lurker)
*   PHP File Locator：一个在大型项目定位文件的库 [官网](https://github.com/herrera-io/php-file-locator)
*   PHP FFmpeg：一个用于[FFmpeg](http://www.ffmpeg.org/) 视频包装的库. [官网](https://github.com/alchemy-fr/PHP-FFmpeg/)
*   CSV：一个CSV数据处理库 [官网](https://github.com/nyamsprod/Bakame.csv)

## 流

_处理流的库_

*   Streamer：一个面向对象的流包装库 [官网](https://github.com/fzaninotto/Streamer)

## 依赖注入

_实现依赖注入设计模式的库_

*   Pimple：一个小的依赖注入容器 [官网](http://pimple.sensiolabs.org/)
*   Auryn：另一个依赖注入容器 [官网](https://github.com/rdlowrey/Auryn)
*   Orno DI：另一个可伸缩的依赖注入容器 [官网](https://github.com/orno/di)
*   PHP DI：一个使用注释实现的依赖注入 [官网](http://mnapoli.github.com/PHP-DI/)
*   Acclimate：一个依赖注入容器和服务定位的通用接口 [官网](https://github.com/jeremeamia/acclimate)

## 图像

_处理图像的库_

*   Imagine：一个图像处理库 [官网](http://imagine.readthedocs.org/en/latest/index.html)
*   PHP Image Workshop：另一个图像处理库 [官网](https://github.com/Sybio/ImageWorkshop)
*   Intervention Image：另一个图像处理库 [官网](https://github.com/Intervention/image)
*   GIF Frame Extractor：一个提取GIF动画帧信息的库 [官网](https://github.com/Sybio/GifFrameExtractor)
*   GIF Creator：一个通过多张图片创建GIF动画的库 [官网](https://github.com/Sybio/GifCreator)
*   Image With Text：一个在图像中嵌入文本的库 [官网](https://github.com/nmcteam/image-with-text)
*   Color Extractor：一个从图像中提取颜色的库 [官网](https://github.com/php-loep/color-extractor)

## 测试

_测试代码和生成测试数据的库_

*   PHPUnit：一个单元测试框架 [官网](https://github.com/sebastianbergmann/phpunit)
*   DBUnit：PHPUnit的数据库测试库 [官网](https://github.com/sebastianbergmann/dbunit)
*   ParaTest：PHPUnit的并行测试库 [官网](https://github.com/brianium/paratest)
*   PHPSpec：基于功能点设计的单元测试库 [官网](https://github.com/phpspec/phpspec)
*   Codeception：一个全栈测试框架 [官网](https://github.com/Codeception/Codeception)
*   AspectMock： PHPUnit/ Codeception 模拟框架。 [官网](https://github.com/Codeception/AspectMock)
*   Atoum：一个简单的测试库 [官网](https://github.com/atoum/atoum)
*   Mockery：一个用测试的模拟对象库 [官网](https://github.com/padraic/mockery)
*   Phake：另一个用测试的模拟对象库 [官网](https://github.com/mlively/Phake)
*   Prophecy：一个可选度很高的模拟框架 [官网](https://github.com/phpspec/prophecy)
*   Faker：一个伪数据生成库 [官网](https://github.com/fzaninotto/Faker)
*   Samsui：另一个伪数据生成库 [官网](https://github.com/mauris/samsui)
*   Alice：富有表现力的一代库 [官网](https://github.com/nelmio/alice)
*   Behat：一个行为驱动开发（BDD）测试框架 [官网](http://behat.org/)
*   Pho：一个行为驱动开发测试框架 [官网](https://github.com/danielstjules/pho)
*   Mink：Web验收测试 [官网](http://mink.behat.org/)
*   HTTP Mock：一个在单元测试模拟HTTP请求的库 [官网](https://github.com/InterNations/http-mock)
*   Stream：一个用于测试的虚拟文件系统流的包装器 [VFS 官网](https://github.com/mikey179/vfsStream)
*   VFS：另一个用于测试虚拟文件系统 [官网](https://github.com/adlawson/vfs.php)
*   Locust：一个用Python编写的现代加载测试库 [官网](http://locust.io/)

## 持续集成

_持续集成的库和应用_

*   Travis CI：一个持续集成平台 [官网](https://travis-ci.org/)
*   PHPCI：一个PHP的开源持续集成平台 [官网](http://www.phptesting.org/)
*   Sismo：一个持续测试服务库 [官网](http://sismo.sensiolabs.org/)
*   Jenkins-PHP：支持[Jenkins](http://jenkins-ci.org/)的一个持续集成平台 [官网](http://jenkins-php.org/index.html)
*   JoliCi：一个用PHP编写的由Docker支持的持续集成客户端 [官网](https://github.com/jolicode/JoliCi)

## 文档

_生成项目文档的库_

*   Sami：一个API文档生成器 [官网](https://github.com/fabpot/Sami)
*   APIGen：另一个API文档生成器 [官网](https://github.com/apigen/apigen)
*   PHP Documentor 2：一个API文档生成器 [官网](https://github.com/phpDocumentor/phpDocumentor2)
*   phpDox：一个PHP项目的文档生成器（不限于API文档） [官网](http://phpdox.de/)

## 安全

_生成安全的随机数，加密数据，扫描漏洞的库_

*   HTML Purifier：一个兼容标准的HTML过滤器 [官网](https://github.com/ezyang/htmlpurifier)
*   RandomLib：一个生成随机数和字符串的库 [官网](https://github.com/ircmaxell/RandomLib)
*   True Random：使用 [www.random.org](http://www.random.org/)生成随机数的库 [官网](https://github.com/pixeloution/true-random)
*   SecurityMultiTool：一个PHP安全库 [官网](https://github.com/padraic/SecurityMultiTool)
*   PHPSecLib：一个纯PHP安全通信库 [官网](http://phpseclib.sourceforge.net/)
*   TCrypto：一个简单的键值加密存储库 [官网](https://github.com/timoh6/TCrypto)
*   IDS： 一个结构化的PHP安全层 [PHP 官网](https://github.com/PHPIDS/PHPIDS)
*   PHP-SSH：一个试验的面向对象的SSH包装库 [官网](https://github.com/Herzult/php-ssh)
*   IniScan：一个扫描PHP INI文件安全的库 [官网](https://github.com/psecio/iniscan)
*   SensioLabs Security Check：一个为检查Composer依赖提供安全建议的web工具 [官网](https://security.sensiolabs.org/)
*   Zed：一个集成的web应用渗透测试工具 [官网](https://www.owasp.org/index.php/OWASP_Zed_Attack_Proxy_Project)

## 密码

_处理和存储密码的库和工具_

*   Password Compat：一个新的PHP5.5密码函数的兼容库 [官网](https://github.com/ircmaxell/password_compat)
*   phpass： 一个便携式的密码哈希框架 [官网](http://www.openwall.com/phpass/)
*   PHP Password Lib：一个生成和校验密码的库 [官网](https://github.com/ircmaxell/PHP-PasswordLib)
*   Password Policy：一个PHP和JavaScript的密码策略库 [官网](https://github.com/ircmaxell/password-policy)
*   Password Validator：校验和升级密码哈希的库 [官网](https://github.com/jeremykendall/password-validator)
*   Zxcvbn PHP：一个基于Zxcvbn JS的现实的PHP密码强度估计库 [官网](https://github.com/bjeavons/zxcvbn-php)

## 代码分析

_分析，解析和处理代码库的库的工具_

*   PHP Parser：一个PHP编写的PHP解析器 [官网](https://github.com/nikic/PHP-Parser)
*   PHPPHP： 一个PHP实现的PHP虚拟机 [官网](https://github.com/ircmaxell/PHPPHP)
*   PHPSandbox：一个PHP沙盒环境 [官网](https://github.com/fieryprophet/php-sandbox)
*   Dissect：一个词法和语法分析的工具集合 [官网](https://github.com/jakubledl/dissect)
*   PHP Mess Detector：一个扫描代码缺陷,次优代码，未使用的参数等等的库。 [官网](http://phpmd.org/)
*   PHP Code Sniffer：一个检测PHP、CSS和JS代码标准冲突的库 [官网](https://github.com/squizlabs/PHP_CodeSniffer)
*   PHPCPD： 一个检测复制和粘贴代码的库 [官网](https://github.com/sebastianbergmann/phpcpd)
*   PHP Analyser：一个分析PHP代码查找缺陷和错误的库 [官网](https://github.com/scrutinizer-ci/php-analyzer)
*   PHP CS Fixer： 一个编码标准库 [官网](https://github.com/fabpot/PHP-CS-Fixer)
*   PHP Manipulator：一个分析和修改PHP源代码的库 [官网](https://github.com/schmittjoh/php-manipulator)
*   PHP Metrics：一个静态测量库 [官网](https://github.com/Halleck45/PhpMetrics)
*   PHP Refactoring Browser：一个重构PHP代码的命令行工具集 [官网](https://github.com/QafooLabs/php-refactoring-browser)
*   UBench：一个简单的微型基准检测库 [官网](https://github.com/devster/ubench)
*   Athletic：一个基于注释的基准检测库 [官网](https://github.com/polyfractal/athletic)
*   Mondrian： 使用使用图论的代码分析工具 [官网](https://github.com/Trismegiste/Mondrian)
*   Scrutinizer：一个审查PHP代码的web工具 [官网](https://scrutinizer-ci.com/)
*   PHPLOC：一个快速测量PHP项目大小的工具 [官网](https://github.com/sebastianbergmann/phploc)
*   xHprof：另一个PHP分析工具 [官网](https://github.com/phacility/xhprof)
*   PHPCheckstyle：一个帮助遵守特定的编码惯例的工具。 [官网](https://github.com/jbrooksuk/phpcheckstyle)

## 调试

_调试代码的库和工具_

*   xDebug：一个调试和分析PHP的工具 [官网](https://github.com/xdebug/xdebug)
*   PHP Debug Bar： 一个调试工具栏 [官网](http://phpdebugbar.com/)
*   PHP Console：一个web调试控制台 [官网](https://github.com/Seldaek/php-console)
*   Barbushin PHP Console：另一个使用Google Chrome的web调试控制台 [官网](https://github.com/barbushin/php-console)
*   PHPDBG：一个交互的PHP调试器 [官网](http://phpdbg.com/)
*   Tracy：一个简单的错误检测，写日志和时间测量库 [官网](https://github.com/nette/tracy)

## 构建工具

_项目构建和自动化工具_

*   Go：一个简单的PHP构建工具 [官网](https://github.com/herrera-io/php-go)
*   Bob：一个简单的项目自动化工具 [官网](https://github.com/CHH/bob)
*   Phake：一个PHP克隆库 [官网](https://github.com/jaz303/phake)
*   Box：一个构建PHAR文件的工具 [官网](https://github.com/kherge/Box)
*   Phing：一个灵感来自于Apache Ant的PHP项目构建系统 [官网](http://www.phing.info/)

## 任务运行器

_自动运行任务的库_

*   Task：一个灵感来源于Grunt和Gulp的纯PHP任务运行器 [官网](http://taskphp.github.io/)
*   Robo：一个面向对象配置的PHP任务运行器 [官网](https://github.com/Codegyre/Robo)
*   Bldr：一个构建在Symfony组件上的PHP任务运行器 [官网](http://bldr.io/)

## 导航

_构建导航结构的工具_

*   KnpMenu：一个菜单库 [官网](https://github.com/KnpLabs/KnpMenu)
*   Cartographer：一个站点地图生成库 [官网](https://github.com/tackk/cartographer)

## 资源管理

_管理，压缩和最小化web站点资源的工具_

*   Assetic：一个资源管理的管道库 [官网](https://github.com/kriswallsmith/assetic)
*   Pipe：另一个资源管理的管道库 [官网](https://github.com/CHH/pipe)
*   Munee：一个资源优化库 [官网](https://github.com/meenie/munee)
*   JShrink：一个JavaScript最小化库 [官网](https://github.com/tedivm/JShrink)
*   Puli：一个检测资源绝对路径的库 [官网](https://github.com/webmozart/puli)

## 地理位置

_为地理编码地址和使用纬度经度的库。_

*   GeoCoder：一个地理编码库 [官网](http://geocoder-php.org/)
*   GeoTools：一个地理工具相关的库 [官网](https://github.com/php-loep/Geotools)
*   PHPGeo：一个简单的地理库 [官网](https://github.com/mjaschen/phpgeo)
*   GeoJSON：一个地理JSON的实现 [官网](https://github.com/jmikola/geojson)

## 日期和时间

_处理日期和时间的库_

*   Carbon：一个简单的日期时间API扩展 [官网](https://github.com/briannesbitt/Carbon)
*   ExpressiveDate：另一个日期时间API扩展 [官网](https://github.com/jasonlewis/expressive-date)
*   CalendR：一个日历管理库 [官网](http://yohan.giarel.li/CalendR)

## 事件

_时间驱动或非阻塞事件循环实现的库_

*   React：一个事件驱动的非阻塞I/O库 [官网](https://github.com/reactphp/react)
*   Rx.PHP：一个reactive扩展库 [官网](https://github.com/asm89/Rx.PHP)
*   Ratchet： 一个web套接字库 [官网](https://github.com/cboden/Ratchet)
*   Hoa WebSocket：另一个web套接字库 [官网](https://github.com/hoaproject/Websocket)
*   Hoa EventSource：一个事件源库 [官网](https://github.com/hoaproject/Eventsource)
*   Evenement：一个事件分发库 [官网](https://github.com/igorw/evenement)
*   FuelPHP Event：另一个事件分发库 [官网](https://github.com/fuelphp/event)

## 日志

_生成和处理日志文件的库_

*   Monolog：一个全面的日志工具 [官网](https://github.com/Seldaek/monolog)
*   KLogger：一个易用的PSR-3兼容的日志类 [官网](https://github.com/katzgrau/KLogger)

## 电子商务

_处理支付和构建在线电子商务商店的库和应用_

*   OmniPay：一个框架混合了多网关支付处理的库 [官网](https://github.com/adrianmacneil/omnipay)
*   Payum：一个支付抽象库 [官网](https://github.com/payum/payum)
*   Sylius：一个开源的电子商务解决方案 [官网](http://www.sylius.org/)
*   Thelia：另一个开源的电子商务解决方案 [官网](http://thelia.net/v2/)
*   Money：一个Fowler金钱模式的PHP实现 [官网](https://github.com/mathiasverraes/money)
*   Sebastian Money：另一个处理货币值的库 [官网](https://github.com/sebastianbergmann/money)
*   Swap：一个汇率库 [官网](https://github.com/florianv/swap)

## PDF

_处理PDF文件的库和软件_

*   Snappy：一个PDF和图像生成器库 [官网](https://github.com/KnpLabs/snappy)
*   WKHTMLToPDF：一个将HTML转换为PDF的工具 [官网](https://github.com/antialize/wkhtmltopdf)

## 数据库

_使用对象关系映射（ORM）或数据映射技术的数据库交互库_

*   Doctrine：一个全面的DBAL和ORM [官网](http://www.doctrine-project.org/)
*   Doctrine Extensions：一个Doctrine行为扩展的集合 [官网](https://github.com/l3pp4rd/DoctrineExtensions)
*   Propel：一个快速的ORM，迁移库和查询构架器 [官网](http://www.propelorm.org/)
*   Eloquent：Laravel 4 ORM [官网](https://github.com/illuminate/database)
*   Baum：一个Eloquent的嵌套集实现 [官网](https://github.com/etrepat/baum)
*   Spot2：一个MySQL的ORM映射器 [官网](https://github.com/vlucas/spot2)
*   RedBean：一个轻量级，低配置的ORM [官网](http://redbeanphp.com/)
*   Pomm：一个PostgreSQL对象模型管理器 [官网](https://github.com/chanmix51/Pomm)
*   ProxyManager：一个为数据映射生成代理对象的工具集 [官网](https://github.com/Ocramius/ProxyManager)

## 迁移

帮助管理数据库模式和迁移的库

*   PHPMig：另一个迁移管理库 [官网](https://github.com/davedevelopment/phpmig)
*   Phinx：另一个数据库迁移管理库 [官网](https://github.com/robmorgan/phinx)
*   Migrations：一个迁移管理库 [官网](https://github.com/icomefromthenet/Migrations)
*   Doctrine Migrations：一个Doctrine迁移库 [官网](http://docs.doctrine-project.org/projects/doctrine-migrations/en/latest/toc.html)

## NoSQL

_处理NoSQL后端的库_

*   MongoQB：一个MongoDB查询构建库 [官网](https://github.com/alexbilbie/MongoQB)
*   Monga：一个MongoDB抽象库 [官网](https://github.com/thephpleague/monga)
*   Predis： 一个功能完整的Redis库 [官网](https://github.com/nrk/predis)

## 队列

_处理事件和任务队列的库_

*   Pheanstalk：一个Beanstalkd 客户端库 [官网](https://github.com/pda/pheanstalk)
*   HP AMQP：一个纯PHP AMQP库 [P官网](https://github.com/videlalvaro/php-amqplib)
*   Thumper： 一个RabbitMQ模式库 [官网](https://github.com/videlalvaro/Thumper)
*   Bernard：一个多后端抽象库 [官网](https://github.com/bernardphp/bernard)

## 搜索

_在数据上索引和执行查询的库和软件_

*   ElasticSearch PHP：ElasticSearch的官方客户端库 [官网](https://github.com/elasticsearch/elasticsearch-php)
*   Elastica：ElasticSearch的客户端库 [官网](https://github.com/ruflin/Elastica)
*   Solarium：Solr的客户端库 [官网](http://www.solarium-project.org/)
*   SphinxQL query builder：Sphinx搜索引擎的的查询库 [官网](http://foolcode.github.io/SphinxQL-Query-Builder/)

## 命令行

_构建命令行工具的库_

*   Boris：一个微型PHP REPL [官网](https://github.com/d11wtq/boris)
*   PsySH：另一个微型PHP REPL [官网](https://github.com/bobthecow/psysh)
*   Pecan：一个事件驱动和非阻塞内核 [官网](https://github.com/mcrumm/pecan)
*   GetOpt：一个命令行选择解析器 [官网](https://github.com/ulrichsg/getopt-php)
*   OptParse：另一个命令行选择解析器 [官网](https://github.com/CHH/optparse)
*   Commando：另一个简单的命令行选择解析器 [官网](https://github.com/nategood/commando)
*   GetOptionKit：另一个命令行选择解析器 [官网](https://github.com/c9s/php-GetOptionKit)
*   Cron Expression：计算cron运行日期的库 [官网](https://github.com/mtdowling/cron-expression)
*   ShellWrap：一个简单的命令行包装库 [官网](https://github.com/MrRio/shellwrap)
*   Hoa Console：另一个命令行库 [官网](https://github.com/hoaproject/Console)
*   Shunt：一个在多台远程机器上并行运行命令行的库 [官网](https://github.com/php-loep/shunt)
*   Cilex：一个构建命令行工具的微型框架 [官网](https://github.com/Cilex/Cilex)

## 身份验证

_实现身份验证的库_

*   Sentry：一个混合的身份验证和授权的框架库 [官网](https://github.com/cartalyst/sentry)
*   Sentry Social：一个社交网络身份验证库 [官网](http://docs.cartalyst.com/sentry-social-2/introduction)
*   Opauth：一个多渠道的身份验证框架 [官网](https://github.com/opauth/opauth)
*   OAuth2：一个OAuth2身份验证服务，资源服务器和客户端库 [官网](https://github.com/php-loep/oauth2-server)
*   OAuth2 Server：另一个OAuth2服务器实现 [官网](http://bshaffer.github.io/oauth2-server-php-docs/)
*   PHP oAuthLib：另一个OAuth库 [官网](https://github.com/Lusitanian/PHPoAuthLib)
*   TwitterOAuth：一个Twitter OAuth库 [官网](https://github.com/ruudk/twitteroauth)
*   TwitterSDK：一个完全测试的Twitter SDK [官网](https://github.com/lyrixx/twitter-sdk)
*   Hawk：一个Hawk HTTP身份认证库 [官网](https://github.com/dflydev/dflydev-hawk)
*   HybridAuth：一个开源的社交登陆库 [官网](https://github.com/hybridauth/hybridauth)

## 标记

_处理标记的库_

*   Decoda：一个轻量级标记解析库 [官网](http://milesj.me/code/php/decoda)
*   PHP Markdown：一个Markdown解析器 [官网](https://github.com/michelf/php-markdown)
*   CommonMark PHP：一个对 [CommonMark spec](https://jgm.github.io/stmd/spec.html)全支持的Markdown解析器 [官网](https://github.com/thephpleague/commonmark)
*   Dflydev Markdown：另一个Markdown解析器 [官网](https://github.com/dflydev/dflydev-markdown)
*   Parsedown：另一个Markdown解析器 [官网](https://github.com/erusev/parsedown)
*   Ciconia：另一个支持Github Markdown风格的Markdown解析器 [官网](https://github.com/kzykhys/Ciconia)
*   Cebe Markdown：一个快速的可扩展的Markdown解析器 [官网](https://github.com/cebe/markdown)
*   HTML5 PHP：一个HTML5解析和序列化库 [官网](https://github.com/Masterminds/html5-php)

## 字符串

_解析和处理字符串的库_

*   ANSI to HTML5：ANSI到HTML5的转化库 [官网](https://github.com/sensiolabs/ansi-to-html)
*   Patchwork UTF-8：一个处理UTF-8字符串的便携库 [官网](https://github.com/nicolas-grekas/Patchwork-UTF8)
*   Hoa String：另一个UTF-8字符串库 [官网](https://github.com/hoaproject/String)
*   Stringy：一个多字节支持的字符串处理库 [官网](https://github.com/danielstjules/Stringy)
*   Color Jizz：处理和转换颜色的库 [官网](https://github.com/mikeemoo/ColorJizz-PHP)
*   UUID： 生成UUIDs的库 [官网](https://github.com/ramsey/uuid)
*   Slugify：转换字符串到slug的库 [官网](https://github.com/cocur/slugify)
*   Urlify： 一个Django的 URLify.jsPHP通道 [官网](https://github.com/jbroadway/urlify)
*   Text： 一个文本处理库 [官网](https://github.com/kzykhys/Text)
*   SQL Formatter：一个格式化SQL语句的库 [官网](https://github.com/jdorn/sql-formatter/)
*   UA Parser： 一个解析用户代理字符串的库 [官网](https://github.com/tobie/ua-parser/tree/master/php)

## 数字

_处理数字的库_

*   Numbers PHP：处理数字的库 [官网](https://github.com/powder96/numbers.php)
*   Math：处理大数字的库 [官网](https://github.com/moontoast/math)
*   ByteUnits：在二进制和度量系统中解析,格式化和转换字节单元的库 [官网](https://github.com/gabrielelana/byte-units)
*   PHP Units of Measure：一个计量单位转换的库 [官网](https://github.com/triplepoint/php-units-of-measure)
*   PHP Conversion：另一个计量单位转换的库 [官网](https://github.com/Crisu83/php-conversion)
*   LibPhoneNumber for PHP：Google电话号码处理的PHP实现库 [官网](https://github.com/giggsey/libphonenumber-for-php)

## 过滤和验证

_过滤和验证数据的库_

*   Filterus：一个简单的PHP过滤库 [官网](https://github.com/ircmaxell/filterus)
*   Respect Validate：一个简单的验证库 [官网](https://github.com/Respect/Validation)
*   Valitron：另一个验证库 [官网](https://github.com/vlucas/valitron)
*   Upload：一个处理文件上传和验证的库 [官网](https://github.com/codeguy/Upload)
*   DMS Filter：一个注释过滤库 [官网](https://github.com/rdohms/DMS-Filter)
*   MetaYaml：一个支持YAML,JSON和XML的模式验证库 [官网](https://github.com/romaricdrigon/MetaYaml)
*   ISO-codes：验证各种ISO和ZIP编码的库(IBAN、SWIFT/BIC、BBAN、VAT、SSN、UKNIN) [官网](https://github.com/ronanguilloux/IsoCodes)

##  REST API

_开发REST-ful API的库和Web工具_

*   Apigility：一个使用Zend Framework 2构建的API构建器 [官网](https://github.com/zfcampus/zf-apigility-skeleton)
*   Hateoas：一个HOATEOAS REST web服务库 [官网](https://github.com/willdurand/Hateoas)
*   HAL：一个超文本应用语言（HAL)构建库 [官网](https://github.com/blongden/hal)
*   Negotiation：一个内容协商库 [官网](https://github.com/willdurand/Negotiation)
*   Drest：一个将Doctrine实体暴露为REST资源节点的库 [官网](https://github.com/leedavis81/drest)
*   Restler：一个将PHP方法暴露为RESTful web API的轻量级框架 [官网](https://github.com/Luracast/Restler)

## 缓存

_缓存数据的库_

*   Alternative PHP Cache (APC)：打开PHP伪代码缓存 [官网](http://www.php.net/manual/en/book.apc.php)
*   Cache：一个缓存库（Doctrine部分） [官网](https://github.com/doctrine/cache)
*   Stash：另一个缓存库 [官网](https://github.com/tedivm/Stash)

## 数据结构和存储

_实现数据结构和存储技术的库_

*   Ardent：一个数据结构库 [官网](https://github.com/morrisonlevi/Ardent)
*   PHP Collections： 一个简单的集合库 [官网](https://github.com/schmittjoh/php-collection)
*   Serializer：一个序列化和反序列化数据的库 [官网](https://github.com/schmittjoh/serializer)
*   PHP Object Storage：一个对象存储库 [官网](https://github.com/herrera-io/php-object-storage)
*   Fractal：一个转换复杂数据结构到JSON输出的库 [官网](https://github.com/php-loep/fractal)
*   Totem：一个管理和穿件数据交换集的库 [官网](http://github.com/Wisembly/Totem)
*   PINQ：一个PHP实时Linq库 [官网](https://github.com/TimeToogo/Pinq)
*   JsonMapper：一个将内嵌JSON结构映射为PHP类的库 [官网](https://github.com/netresearch/jsonmapper)

## 通知

_处理通知软件的库_

*   Nod：一个通知库（Growl等） [官网](https://github.com/filp/nod)
*   Notificato：一个处理推送通知的库 [官网](https://github.com/wrep/notificato)
*   Notification Pusher：一个设备推送通知的独立库 [官网](https://github.com/Ph3nol/NotificationPusher)
*   Notificator：一个轻量级的通知库 [官网](https://github.com/namshi/notificator)

## 部署

_项目部署库_

*   Pomander：一个PHP应用部署工具 [官网](https://github.com/tamagokun/pomander)
*   Rocketeer：PHP世界里的一个快速简单的部署器 [官网](https://github.com/Anahkiasen/rocketeer)
*   Envoy：一个用PHP运行SSH任务的工具 [官网](https://github.com/laravel/envoy)
*   Plum：一个部署库 [官网](https://github.com/aerialls/Plum)

## 国际化和本地化

_国际化（I18n）和本地化（L10n）_

*   [Aura.Intl](http://hao.importnew.com/aura-intl/)：[官网](https://github.com/auraphp/Aura.Intl)

## 第三方API

_访问第三方API的库_

*   Amazon Web Service SDK：PHP AWS SDK官方库 [官网](https://github.com/aws/aws-sdk-php)
*   S3 Stream Wrapper：Amazon S3流包装库 [官网](https://github.com/gwkunze/S3StreamWrapper)
*   Stripe：Stripe官方PHP库 [官网](https://github.com/stripe/stripe-php)
*   Campaign Monitor：Campaign Monitor官方PHP库 [官网](http://campaignmonitor.github.com/createsend-php/)
*   Digital Ocean：Digital Ocean API 接口库 [官网](https://github.com/toin0u/DigitalOcean)
*   Github：Github API交互库 [官网](https://github.com/dsyph3r/github-api3-php)
*   PHP Github API：另一个Github API交互库 [官网](https://github.com/KnpLabs/php-github-api)
*   Twitter OAuth：Twitter OAuth工作流交互库 [官网](https://github.com/widop/twitter-oauth)
*   Twitter REST：Twitter REST API交互库 [官网](https://github.com/widop/twitter-rest)
*   Dropbox SDK：Dropbox SDK官方PHP库 [官网](https://github.com/dropbox/dropbox-sdk-php)
*   Twilio：Twilio官方PHP REST API [官网](https://github.com/twilio/twilio-php)
*   Mailgun：Mailgun官方PHP REST API [官网](https://github.com/mailgun/mailgun-php) 

## 扩展

_帮助构建PHP扩展的库_

*   Zephir：用于开发PHP扩展，且介于PHP和C++之间的编译语言 [官网](https://github.com/phalcon/zephir)
*   [PHP CPP](http://hao.importnew.com/php-cpp/)：一个开发PHP扩展的C++库 [官网](http://www.php-cpp.com/)

## 杂项

_不在上面分类中的有用库和工具_

*   Spork：一个处理forking的库 [官网](https://github.com/kriswallsmith/spork)
*   JSON Lint：一个JSON lint工具 [官网](https://github.com/Seldaek/jsonlint)
*   JSONPCallbackValidator：验证JSONP回调的库 [官网](https://github.com/willdurand/JsonpCallbackValidator)
*   Pagerfanta：一个分页库 [官网](https://github.com/whiteoctober/Pagerfanta)
*   Ruler：一个简单的无状态的生产环境规则引擎。 [官网](https://github.com/bobthecow/Ruler)
*   LiteCQRS：一个CQRS(命令查询责任分离)库 [官网](https://github.com/beberlei/litecqrs-php)
*   Sslurp：一个使得SSL处理减少的库 [官网](https://github.com/EvanDotPro/Sslurp)
*   Option[PHP 官网](https://github.com/schmittjoh/php-option)一个可选的类型库
*   Metrics：一个简单的度量API库 [官网](https://github.com/beberlei/metrics)
*   Sabre VObject：一个解析VCard和iCalendar对象的库 [官网](https://github.com/evert/sabre-vobject)
*   Annotations：一个注释库（Doctrine部分） [官网](https://github.com/doctrine/annotations)
*   Whoops：一个不错的错误处理库 [官网](https://github.com/filp/whoops)
*   Finite：一个简单的PHP有限状态机 [官网](http://yohan.giarel.li/Finite)
*   LadyBug：一个dumper库 [官网](https://github.com/raulfraile/Ladybug)
*   Procrastinator：运行耗时任务的库 [官网](https://github.com/lstrojny/Procrastinator)
*   Compose：一个功能组合库 [官网](https://github.com/igorw/compose)
*   SuperClosure：一个允许闭包序列化的库 [官网](https://github.com/jeremeamia/super_closure)
*   Jumper：一个远程服务执行库 [官网](https://github.com/kakawait/Jumper)
*   Underscore：一个Undersccore JS库的PHP实现 [官网](http://anahkiasen.github.io/underscore-php/)
*   PHP PassBook：一个iOS PassBook PHP库 [官网](https://github.com/eymengunay/php-passbook)
*   PHP Expression：一个PHP表达式语言 [官网](https://github.com/Kitano/php-expression)
*   RMT：一个编写版本和发布软件的库 [官网](https://github.com/liip/RMT)
*   Wise：一个配置管理器 [官网](https://github.com/herrera-io/php-wise)
*   Opengraph：一个开放图库 [官网](https://github.com/euskadi31/Opengraph)
*   Essence：一个提取web媒体的库 [官网](https://github.com/felixgirault/essence)
*   Embera：一个Oembed消费库 [官网](https://github.com/mpratt/Embera)
*   Graphviz：一个图形库 [官网](https://github.com/alexandresalome/graphviz)
*   Monad PHP：[官网](https://github.com/ircmaxell/monad-php) 一个简单Monad库
*   Flux：一个正则表达式构建库 [官网](https://github.com/selvinortiz/flux)
*   Patchwork：一个重新定义用户的函数库 [官网](http://antecedent.github.io/patchwork/)
*   Galapagos：语言转换进化 [官网](https://github.com/igorw/galapagos)
*   Design Patterns PHP：一个使用PHP实现的设计模式存储库 [官网](https://github.com/domnikl/DesignPatternsPHP)
*   PHPCR：一个Java内容存储库（JCR)的PHP实现 [官网](https://github.com/phpcr/phpcr)
*   Functional PHP：一个函数式编程库 [官网](https://github.com/lstrojny/functional-php)
*   ClassPreloader：一个优化自动加载的库 [官网](https://github.com/mtdowling/ClassPreloader)
*   Lib Country：一个国家和地区数据的库 [官网](https://github.com/phine/lib-country)
*   Lib Accessor：一个简化访问的库 [官网](https://github.com/phine/lib-accessor)
*   PHPStack：一个PHP编写的TCP/IP栈概念 [官网](http://dunkels.com/adam/phpstack/)
*   Nmap：一个Nmap PHP包装器 [官网](https://github.com/willdurand/nmap)
*   Code Mover：一个移动代码的库 [官网](https://github.com/dantleech/code-mover)
*   Iter：一个使用生成器提供迭代原语的库 [官网](https://github.com/nikic/iter)
*   Lambda PHP：一个PHP中的Lambda 计算解析器 [官网](https://github.com/igorw/lambda-php)
*   Country List：所有带有名称和ISO 3166-1编码的国家列表 [官网](https://github.com/umpirsky/country-list)
*   PHP-GPIO：用于Raspberry PI的GPIO pin的库 [官网](https://github.com/ronanguilloux/php-gpio)
*   print_o：一个对象图的可视化器 [官网](https://github.com/koriym/print_o)
*   Alias：一个类别名库 [官网](https://github.com/fuelphp/alias)

# 软件

_创建一个开发环境的软件_

## PHP安装

_在你的电脑上帮助安装和管理PHP的工具_

*   HomeBrew：一个OSX包管理器 [官网](http://mxcl.github.com/homebrew/)
*   HomeBrew PHP：一个HomeBrew的PHP通道 [官网](https://github.com/josegonzalez/homebrew-php)
*   PHP OSX：一个OSX下的PHP安装器 [官网](http://php-osx.liip.ch/)
*   PHP Brew：一个PHP版本管理和安装器 [官网](https://github.com/c9s/phpbrew)
*   PHP Env：另一个PHP版本管理器 [官网](https://github.com/CHH/phpenv)
*   PHP Switch：另一个PHP版本管理器 [官网](https://github.com/jubianchi/phpswitch)
*   PHP Build：另一个PHP版本安装器 [官网](https://github.com/CHH/php-build)
*   VirtPHP：一个创建和管理独立PHP环境的工具 [官网](http://virtphp.org/)

## 开发环境

_创建沙盒开发环境的软件和工具_

*   Vagrant：一个便携的开发环境工具 [官网](http://www.vagrantup.com/)
*   Ansible：一个非常简单的编制框架 [官网](http://www.ansibleworks.com/)
*   Puppet：一个服务器自动化框架和应用 [官网](http://puppetlabs.com/)
*   PuPHPet：一个构建PHP开发虚拟机的web工具 [官网](https://puphpet.com/)
*   Protobox：另一个构建PHP开发虚拟机的web工具 [官网](http://getprotobox.com/)
*   Phansible：一个用Ansible构建PHP开发虚拟机的web工具 [官网](http://phansible.com/)

## 虚拟机

_相关的PHP虚拟机_

*   HipHop PHP：Facebook出品的PHP虚拟机，运行时和JIT [官网](https://github.com/facebook/hiphop-php)
*   HippyVM：另一个PHP虚拟机 [官网](http://hippyvm.com/)
*   Hack：一个PHP进行无缝操作的 [HHVM](https://github.com/facebook/hiphop-php)编程语言 [官网](http://hacklang.org/)

## IDE

_支持PHP的集成开发环境_

*   Netbeans：一个支持PHP和HTML5的IDE [官网](https://netbeans.org/)
*   Eclipse for PHP Developers：一个基于Eclipse平台的PHP IDE [官网](https://www.eclipse.org/downloads/)
*   [PhpStorm](http://hao.importnew.com/phpstorm/)：一个商业PHP IDE [官网](http://www.jetbrains.com/phpstorm/)
*   [Sublime Text] ：一个轻量级的PHP IDE [官网](http://www.sublimetext.com/)

## Web应用

_基于Web的应用和工具_

*   3V4L：一个在线的PHP shell [官网](http://3v4l.org/)
*   DBV：一个数据库版本控制应用 [官网](http://dbv.vizuina.com/)
*   PHP Queue：一个管理后端队列的应用 [官网](https://github.com/CoderKungfu/php-queue)
*   Composer as a Service：作为一个zip文件下载Composer包的工具 [官网](http://composer.borreli.com/)
*   MailCatcher：一个抓取和查看邮件的web工具 [官网](https://github.com/sj26/mailcatcher)

# 资源

各种提高你的PHP开发技能和知识的资源，比如书籍，网站，文章

## PHP网站

_PHP相关的有用网站_

*   PHP The Right Way：一个PHP最佳实践的快速指引手册 [官网](http://www.phptherightway.com/)
*   PHP Best Practices：一个PHP最佳实践指南 [官网](http://phpbestpractices.org/)
*   PHP Weekly：一个PHP新闻周刊 [官网](http://phpweekly.info/archive/)
*   PHP Security：一个PHP安全指南 [官网](http://phpsecurity.readthedocs.org/en/latest/index.html)
*   PHP FIG：PHP框架交互组 [官网](http://www.php-fig.org/)
*   PHP UG：一个帮助用户定位最近的PHP用户组（UG)的网站 [官网](http://php.ug/)
*   Seven PHP：一个PHP社区成员采访的网站 [官网](http://7php.com/)
*   Nomad PHP：一个在线PHP学习资源 [官网](http://nomadphp.com/)
*   PHP Mentoring：点对点PHP导师组织 [官网](http://phpmentoring.org/)

## 其他网站

_Web开发相关的有用网站_

*   The Open Web Application Security Project (OWASP)：一个开放软件安全社区 [官网](https://www.owasp.org/index.php/Main_Page)
*   WebSec IO：一个Web安全社区资源 [官网](http://websec.io/)
*   Web Advent：一个Web开发人员日历 [官网](http://webadvent.org/)
*   Semantic Versioning：一个解析语义版本的网站 [官网](http://semver.org/)
*   Atlassian Git Tutorials：一个Git教程系列 [官网](https://www.atlassian.com/git)
*   Hg Init：一个Mercurial教程系列 [官网](http://hginit.com/)
*   Servers for Hackers：一个关于服务器管理的新闻通讯 [官网](http://serversforhackers.com/)

## PHP书籍

_PHP相关的非常好的书籍_

*   Scaling PHP Applications：一本Steve Corona关于扩展PHP应用程序的电子书 [官网](http://www.scalingphpbook.com/)
*   The Grumpy Programmer's Guide to Building Testable PHP Applications：一本Chris Hartjes关于构建PHP应用程序测试的书 [官网](https://leanpub.com/grumpy-testing)
*   Grumpy PHPUnit：一本Chris Hartjes关于使用PHPUnit进行单元测试的书 [官网](https://leanpub.com/grumpy-phpunit)
*   Mastering Object-Orientated PHP：一本Brandon Savage关于PHP面向对象的书 [官网](http://www.brandonsavage.net/)
*   Signaling PHP：一本Cal Evans关于在CLI脚本捕获PCNTL 信号的书 [官网](https://leanpub.com/signalingphp)
*   Securing PHP: Core Concepts：一本Chris Cornutt关于PHP常见安全条款和实践的书 [官网](https://leanpub.com/securingphp-coreconcepts)
*   Modernising Legacy Applications in PHP：一本Paul M.Jones关于遗留PHP应用进行现代化的书 [官网](https://leanpub.com/mlaphp)

## 其他书籍

_与一般计算和Web开发相关的书_

*   The Linux Command Line：William Shotts关于Linux命令行的一本书 [官网](http://linuxcommand.org/tlcl.php)
*   Understanding Computation：Tom Stuart关于计算理论的一本书 [官网](http://computationbook.com/)
*   The Tangled Web — Securing Web Applications： Michal Zalewski关于web应用安全的一本书 [官网](http://www.amazon.ca/The-Tangled-Web-Securing-Applications/dp/1593273886)
*   Elasticsearch: The Definitive Guide：Clinton Cormley和Zachary Tong编写的与Elasticsearch工作的一本指南 [官网](http://www.elasticsearch.org/guide/)
*   Eloquent JavaScript：Marijin Haverbeke关于JavaScript编程的一本书 [官网](http://eloquentjavascript.net/)
*   Vagrant Cookbook：Erika Heidi关于创建 Vagrant环境的一本书 [官网](https://leanpub.com/vagrantcookbook)
*   Pro Git：Scott Chacon和Ben Straub关于Git的一本书 [官网](http://git-scm.com/book/en/v2)

## PHP视频

_PHP相关的非常不错的视频_

*   Taking PHP Seriously：来自Facebook Keith Adams 讲述PHP优势 [官网](http://www.infoq.com/presentations/php-history)
*   PHP Town Hall：一个随意的Ben Edmunds和Phil Sturgeon的PHP播客 [官网](http://phptownhall.com/)
*   Programming with Anthony：[官网](http://www.youtube.com/playlist?list=PLM-218uGSX3DQ3KsB5NJnuOqPqc5CW2kW)  Anthony Ferrara的视频系列

## PHP阅读

_PHP相关的阅读资料_

*   Create Your Own PHP Framework：一部Fabien Potencier的关于如何创建你自己的PHP框架的系列文章 [官网](http://fabien.potencier.org/article/50/create-your-own-framework-on-top-of-the-symfony2-components-part-1)
*   Seven Ways to Screw Up BCrypt：一篇关于纠正BCrypt实现的文章 [官网](http://blog.ircmaxell.com/2012/12/seven-ways-to-screw-up-bcrypt.html)
*   Preventing CSRF Attacks：一篇组织CSRF攻击的文章 [官网](http://blog.ircmaxell.com/2013/02/preventing-csrf-attacks.html)
*   Don't Worry About BREACH：一篇关于BREACH攻击和CSRF令牌的文章 [官网](http://blog.ircmaxell.com/2013/08/dont-worry-about-breach.html)
*   On PHP 5.3, Lamda Functions and Closures：一篇关于lambda函数和闭包的文章 [官网](http://fabien.potencier.org/article/17/on-php-5-3-lambda-functions-and-closures)
*   Use Env：一篇关于使用unix环境帮助的文章 [官网](http://seancoates.com/blogs/use-env)
*   Composer Primer：Composer初级 [官网](http://daylerees.com/composer-primer)
*   Composer Versioning：一篇关于Composer版本的文章 [官网](https://igor.io/2013/01/07/composer-versioning.html)
*   Composer Stability Flags：一篇关于Composer稳定性标志的文章 [官网](https://igor.io/2013/02/07/composer-stability-flags.html)
*   Innocent Villagefolk or a Pillagin’ Pirate?：一篇关于PHP从其他语言获取想法的文章 [官网](http://blog.astrumfutura.com/2012/04/php-innocent-villagefolk-or-a-pillagin-pirate/)
*   Predicting Random Numbers in PHP：一篇关于生成随机数的文章 [官网](http://blog.astrumfutura.com/2013/03/predicting-random-numbers-in-php-its-easier-than-you-think/)
*   A 20 Point List for Preventing XSS in PHP：一篇关于组织XSS的文章 [官网](http://blog.astrumfutura.com/2013/04/20-point-list-for-preventing-cross-site-scripting-in-php/)
*   PHP Sucks! But I Like It!：一篇关于PHP利弊的文章 [官网](http://blog.ircmaxell.com/2012/04/php-sucks-but-i-like-it.html)
*   PHP Is Much Better Than You Think：一篇关于PHP语言和生态圈的文章 [官网](http://fabien.potencier.org/article/64/php-is-much-better-than-you-think)

## PHP内核阅读

_阅读PHP内核或性能相关的资料_

*   PHP RFCs：PHP RFCs主页（请求注解） [官网](https://wiki.php.net/rfc)
*   PHP Internals Book：一本由三名核心开发编写的关于PHP内核的在线书 [官网](http://www.phpinternalsbook.com/)
*   Print vs Echo, Which One is Faster?：一篇关于打印和echo性能的文章 [官网](http://fabien.potencier.org/article/8/print-vs-echo-which-one-is-faster)
*   The PHP Ternary Operator. Fast or Not?：一篇关于三元操作性能的文章 [官网](http://fabien.potencier.org/article/48/the-php-ternary-operator-fast-or-not)
*   Disproving the Single Quotes Myth：一篇关于单引号，双引号字符串性能的文章 [官网](http://nikic.github.com/2012/01/09/Disproving-the-Single-Quotes-Performance-Myth.html)
*   You're Being Lied To：一篇关于内核ZVALs的文章 [官网](http://blog.golemon.com/2007/01/youre-being-lied-to.html)
*   How Long is a Piece of String：一篇关于字符串原理的文章 [官网](http://blog.golemon.com/2006/06/how-long-is-piece-of-string.html)
*   Understanding OpCodes：一篇关于伪代码的文章 [官网](http://blog.golemon.com/2008/01/understanding-opcodes.html)
*   How Foreach Works：StackOverflow 关于foreach回答的详情 [官网](http://stackoverflow.com/questions/10057671/how-foreach-actually-works/14854568#14854568)
*   When Does Foreach Copy?：一篇关于foreach原理的文章 [官网](http://nikic.github.com/2011/11/11/PHP-Internals-When-does-foreach-copy.html)
*   How Big Are PHP Arrays (And Values) Really?：一篇关于数组原理的文章 [官网](http://nikic.github.com/2011/12/12/How-big-are-PHP-arrays-really-Hint-BIG.html)
*   Why Objects (Usually) Use Less Memory Than Arrays：一篇关于对象和数组原理的文章 [官网](https://gist.github.com/nikic/5015323)
*   PHP Evaluation Order：一篇关于PHP评估顺序的文章 [官网](https://gist.github.com/nikic/6699370)
*   开发人员的PHP源代码： [1](http://blog.ircmaxell.com/2012/03/phps-source-code-for-php-developers.html) [2](http://nikic.github.com/2012/03/16/Understanding-PHPs-internal-function-definitions.html) [3](http://blog.ircmaxell.com/2012/03/phps-source-code-for-php-developers_21.html) [4](http://nikic.github.com/2012/03/28/Understanding-PHPs-internal-array-implementation.html)：关于PHP源代码的系列
*   垃圾收集： [1](http://www.php.net/manual/en/features.gc.refcounting-basics.php) [2](http://www.php.net/manual/en/features.gc.collecting-cycles.php) [3](http://www.php.net/manual/en/features.gc.performance-considerations.php) 关于PHP垃圾收集原理的系列


<h3 id="weibo-weixin">微信公众号</h3>
* PHP开发者：专注分享 PHP 开发相关的技术文章和工具资源
<br><img src="http://ww1.sinaimg.cn/small/63918611gw1epb2cb1xq0j2046046dgv.jpg" width=150 height=150>
